/*
 * small_protokoll.c
 *
 *  Created on: 12.06.2012
 *      Author: Pascal
 */


#include "small_protokoll.h"






void initSmall_Protokoll() {

	i2c_init();

}




uint8_t getLaenge(uint8_t data[]) {
	uint8_t i = 0;

	while(data[i] != LF) {										// abbrechen bei einem LF
		i++;
	}

	return i;
}




uint8_t sendeDaten(uint8_t data[]) {
	uint8_t bcc;
	uint8_t retNak = 0;
	uint8_t len = 0;


	len = getLaenge(data);

	if(len > 2) {													// es sind Daten vorhanden (ein Befehl besteht mind. aus 3 Zeichen)

		//for(uint8_t error = 0; error < 3; error++) {					// bei einem Fehler max. 3 mal senden
			// Daten senden (schreiben)
			i2c_start_wait(DISPLAY_WRITE);								// setze Adresse vom Display und Schreib-Modus

			i2c_write(DC1);												// sende DC1
			i2c_write(len);												// sende Datenlaenge

			bcc = DC1 + len;											// bererchne Prf-(Teil)Summe aus allen Bytes

			for(uint8_t i = 0; i < len; i++) {							// sende Nutzdaten
				i2c_write(data[i]);										// sende Buffer
				bcc = bcc + data[i];									// bererchne Prf-Summe aus allen Bytes
			}

			i2c_write(bcc);												// sende Prf-Summe


			// Quittierung vom Display holen (lesen)
			i2c_rep_start(DISPLAY_READ);								// setze Adresse vom Display und Lese-Modus
			_delay_us(TIME_TO_WAIT); 									// vor jedem lesen warten
			retNak = i2c_readNak();										// Quittierung vom Display lesen
			i2c_stop();													// bertragung beenden

		//	if(retNak == ACK) {											// bertragung erfolgreich - dann Schleife abbrechen
		//		error = 3;
		//	}
		//}

	} else {
		// TODO Fehlermeldung in ein EEPROM schreiben -  es sind keine Daten vorhanden
	}

	return retNak;
}





uint8_t leseDaten() {
	char dataS[] = {S};
	uint8_t bccS, bccCheck, lenS = 1;
	uint8_t ackE = 0;
	struct DATEN_EMPFANG dataE;


	// Initialisiere Struktur
	dataE.dc   = _0_;
	dataE.len  = _0_;
	dataE.data = _0_;
	dataE.bcc  = _0_;

	// Prfsumme berechnen
	bccS  = DC2 + lenS + dataS[0];

	// Daten senden (d.h. sind Nutzdaten vorhanden?)
	i2c_start_wait(DISPLAY_WRITE);									// setze Adresse vom Display und Schreib-Modus
	 
	i2c_write(DC2);													// sende DC2
	i2c_write(lenS);												// sende Datenlnge
	i2c_write(dataS[0]);											// sende Nutzdaten
	i2c_write(bccS);												// sende Prf-Summe


	// Quittierung vom Display holen (lesen)
	i2c_rep_start(DISPLAY_READ);									// setze Adresse vom Display und Lese-Modus 	
	_delay_us(TIME_TO_WAIT);
	ackE = i2c_readAck();											// Quittierung erfolgreich

	if(ackE == ACK) {												// Alles ok - Informationen lesen		
		_delay_us(TIME_TO_WAIT);												// Hinweis: Das Lesen habe ich auch schon ohne das delay probiert
		dataE.dc = i2c_readAck();									// DC2 aus Empfangspuffer bekommen
		
		_delay_us(TIME_TO_WAIT);
		dataE.len = i2c_readAck();									// Lnge aus Empfangspuffer bekommen
		
		_delay_us(TIME_TO_WAIT);
		dataE.data = i2c_readAck();									// Anzahl abholbarer Bytes aus Empfangspuffer bekommen
		
		_delay_us(TIME_TO_WAIT);
		dataE.bcc = i2c_readNak();									// Prfsumme aus Empfangspuffer bekommen

		i2c_stop();
		
		//Prfsumme checken
		bccCheck = (dataE.dc +  dataE.len + dataE.data) % 256;

		if(dataE.bcc != bccCheck) {									// Prfsumme NICHT ok - Daten verloren
			dataE.dc   = _0_;
			dataE.len  = _0_;
			dataE.data = _0_;
			dataE.bcc  = _0_;
		}
	}


	if(ackE == NAK) {
		// TODO Befehl erneut senden ggf. nach einer gewissen Zeit
	}


	return dataE.data;
}
