/*
 * small_protokoll.h
 *
 *  Created on: 12.06.2012
 *      Author: Pascal
 */
#ifndef SMALL_PROTOKOLL_H_
#define SMALL_PROTOKOLL_H_



#include "i2cmaster.h"
#include <util/delay.h>


void initSmall_Protokoll();
uint8_t sendeDaten(uint8_t data[]);
uint8_t leseDaten();



struct DATEN_EMPFANG {
	uint8_t dc;
	uint8_t len;
	uint8_t data;
	uint8_t bcc;
};



// I2C Adressen
#define DISPLAY_WRITE				0xDE					// Display-Adresse zum Schreiben (DE)
#define DISPLAY_READ				0xDF					// Display-Adresse zum Lesen (DF)


// Wartezeit
#define TIME_TO_WAIT				6						// Wartezeit fr Empfangsnachrichten


// Protokollinformationen
#define DC1							0x11					// 17(dez) Bezeichung/Initialisierung fr DC1
#define DC2							0x12					// 18(dez) Bezeichung/Initialisierung fr DC2
#define ACK							0x06					//  6(dez)
#define NAK							0x15					// 21(dez)

// Zeichen
#define NULL						0x00					// NULL
#define ESC							0x23					// #
#define LF							0x0A					// Linefeed
#define CR							0x0D
#define LEER						0x20					// 32(dez) Leerzeichen
#define PROZENT						0x25					// 37(dez) Prozentzeichen
#define KOMMA						0x2C					// 44(dez) ,
#define PUNKT						0x2E					// 46(dez) .

// Zahlen
#define _0_							0x30
#define _1_							0x31
#define _2_							0x32
#define _3_							0x33
#define _4_							0x34
#define _5_							0x35
#define _6_							0x36
#define _7_							0x37
#define _8_							0x38
#define _9_							0x39

// Buchstaben
#define A							0x41					// A
#define B							0x42					// B
#define C							0x43					// C
#define D							0x44					// D
#define E							0x45
#define F							0x46
#define G							0x47
#define H							0x48
#define I							0x49
#define J							0x4A
#define K							0x4B
#define L							0x4C
#define M							0x4D
#define N							0x4E
#define O							0x4F
#define P							0x50
#define Q							0x51
#define R							0x52
#define S							0x53
#define T							0x54
#define U							0x55
#define V							0x56
#define W							0x57
#define X							0x58
#define Y							0x59
#define Z							0x5A

#define a							0x61					// a
#define m							0x6D
#define x							0x78


#endif /* SMALL_PROTOKOLL_H_ */
