#include "small_protokoll.h"

#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>

volatile uint8_t event;

ISR(TIMER1_COMPA_vect) {
	event++; 																		// Erzeuge event in Software
}


void init()
{
	/*** Initialisierung fuer Atmega2561 ***/
	DDRA = 0x00;
	DDRB = 0x00;
	DDRC = 0x00;	
	DDRD = 0xFF;


	TCCR1B = (1 << WGM12);
	TCCR1B |= (1 << CS12) | (1 << CS10);
	OCR1A = 15624;
	TIMSK1 = (1 << OCIE1A);

	initSmall_Protokoll();
    i2c_init;
	sei();																				// Interrupts aktivieren
}


int main(void)
{
	//Hardware Initialisierungen
	init();

	uint8_t ID = 0;
	
	
	for (;;) {

		// 5ms
		if (event >= 10) {
			/* IDs nach Display schreiben */
			ID=leseDaten();
			if(ID == 5) {
				//TODO: Erledige eine Aufgabe
			}
		

		}

	}

}
